Index: protocol/src/main/java/geniusweb/protocol/tournament/allpermutationslearn/AllPermutationsLearnProtocol.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/tournament/allpermutationslearn/AllPermutationsLearnProtocol.java	(revision 31)
+++ protocol/src/main/java/geniusweb/protocol/tournament/allpermutationslearn/AllPermutationsLearnProtocol.java	(revision 31)
@@ -0,0 +1,48 @@
+package geniusweb.protocol.tournament.allpermutationslearn;
+
+import geniusweb.protocol.tournament.TournamentState;
+import geniusweb.protocol.tournament.allpermutations.AllPermutationsProtocol;
+import geniusweb.protocol.tournament.allpermutations.AllPermutationsState;
+import geniusweb.references.ProtocolRef;
+import tudelft.utilities.logging.Reporter;
+
+/**
+ * This protocol creates sequentially all permutations of available parties and
+ * profiles, See {@link AllPermutationsLearnSettings} for details. Only 1
+ * session is run at a time because managing multiple sessions is more complex
+ * to manage in the {@link TournamentState}
+ * 
+ */
+public class AllPermutationsLearnProtocol extends AllPermutationsProtocol {
+	private static final ProtocolRef APPLearn = new ProtocolRef("APPLearn");
+
+	/**
+	 * 
+	 * @param state  the {@link AllPermutationsState}
+	 * @param logger used for all logging, about the tournament, and the created
+	 *               the session and protocols.
+	 */
+	public AllPermutationsLearnProtocol(AllPermutationsLearnState state,
+			Reporter logger) {
+		super(state, logger);
+	}
+
+	@Override
+	public String getDescription() {
+		return "Runs all possible permutations of provided parties and profiles, "
+				+ "with the given number of parties per session. Sessions run one at a time. "
+				+ "In each session, all parties receive FileLocations in the 'negotiationdata' parameter."
+				+ "If reuseParties is set, then a party can occur more than 1 time in each session. "
+				+ "The sessionSettings determine the baseline settings for each session, eg the deadline "
+				+ "and the protocol to be used. The AllPermutationsProtocol supports all basic SessionProtocols. "
+				+ "parties and protocols already available in the settings will participate in every session. "
+				+ "After all sessions have been run, a Learn session is done where all parties receive their"
+				+ "previously stored FileLocations again.";
+	}
+
+	@Override
+	public ProtocolRef getRef() {
+		return APPLearn;
+	}
+
+}
Index: protocol/src/main/java/geniusweb/protocol/tournament/allpermutationslearn/AllPermutationsLearnSettings.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/tournament/allpermutationslearn/AllPermutationsLearnSettings.java	(revision 31)
+++ protocol/src/main/java/geniusweb/protocol/tournament/allpermutationslearn/AllPermutationsLearnSettings.java	(revision 31)
@@ -0,0 +1,264 @@
+package geniusweb.protocol.tournament.allpermutationslearn;
+
+import java.math.BigInteger;
+import java.net.URISyntaxException;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.List;
+import java.util.stream.Collectors;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.FileLocation;
+import geniusweb.protocol.session.SessionSettings;
+import geniusweb.protocol.session.TeamInfo;
+import geniusweb.protocol.session.learn.LearnSettings;
+import geniusweb.protocol.tournament.ProfileList;
+import geniusweb.protocol.tournament.Team;
+import geniusweb.protocol.tournament.TournamentProtocol;
+import geniusweb.protocol.tournament.allpermutations.AllPermutationsSettings;
+import geniusweb.references.Parameters;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProfileRef;
+import tudelft.utilities.immutablelist.FixedList;
+import tudelft.utilities.immutablelist.ImmutableList;
+import tudelft.utilities.immutablelist.JoinedList;
+import tudelft.utilities.immutablelist.MapThreadList;
+import tudelft.utilities.logging.Reporter;
+
+/**
+ * Almost the same as AllPermutationsSettings.
+ * <p>
+ * The only additional field is the additional learnTime. This has a maximum to
+ * the maximum number of sessions, {@link #MAX_SESSIONS}. This is because we
+ * need to store all the {@link FileLocation}s explicitly.
+ * <p>
+ * Only the first team member is actually getting the learn time.
+ * <p>
+ * We assume that all parties have the proper persistentstate parameter already.
+ * This is assumed to be set in the {@link Team} settings
+ */
+public class AllPermutationsLearnSettings extends AllPermutationsSettings {
+
+	/**
+	 * MAX_SESSIONS is the maximum number of sessions in a tournament. It is
+	 * depending on a number of factors:
+	 * <ul>
+	 * <li>The memory use to store all UUIDs for all parties
+	 * <li>The MAX_MESSAGE_SIZE of a websocket message.
+	 * </ul>
+	 * The MAX_MESSAGE_SIZE of the partyserver currently is 20MB. A single UUID
+	 * is about 45 bytes including double quotes and commas
+	 * </ul>
+	 */
+	private final static int MAX_SESSIONS = 400000;
+	private final static ObjectMapper jackson = new ObjectMapper();
+
+	private final LearnSettings learnSettings;
+
+	/**
+	 * 
+	 * @param teams           a list of {@link Team}s. Must contain at least
+	 *                        {@link #teamsPerSession} elements. The
+	 *                        {@link #teamsPerSession} must match the protocol:
+	 *                        (SAOP:1, SHAOP:2)
+	 * @param reuseTeams      if true, we use PermutationsWithReturn, if false
+	 *                        we use PermutationsWithoutReturn to create the
+	 *                        teams.
+	 * @param plists          list of available {@link ProfileList}s to be
+	 *                        permutated over the teams. Each
+	 *                        {@link ProfileList} must contain
+	 *                        {@link #teamsPerSession} elements.
+	 * @param teamsPerSession number of parties per session, must be at least 2.
+	 * @param sesettings      The generic {@link SessionSettings}.
+	 *                        {@link SessionSettings#with(TeamInfo)} will be
+	 *                        used to add the required {@link TeamInfo}s. All
+	 *                        settings must contain a 'persistentstate'
+	 *                        parameter with a {@link FileLocation}.
+	 * @param nTournaments    the number of times the tournament should be run.
+	 * @param learnSet        the {@link LearnSettings} to be used for the
+	 *                        learning phase. The participants list should be
+	 *                        empty as this will be filled up from the teams
+	 *                        provided above. Only the deadline is used.
+	 */
+	@JsonCreator
+	public AllPermutationsLearnSettings(@JsonProperty("teams") List<Team> teams,
+			@JsonProperty("profileslists") List<ProfileList> plists,
+			@JsonProperty("reuseTeams") boolean reuseTeams,
+			@JsonProperty("teamsPerSession") int teamsPerSession,
+			@JsonProperty("sessionsettings") SessionSettings sesettings,
+			@JsonProperty("numberTournaments") int nTournaments,
+			@JsonProperty("learnSettings") LearnSettings learnSet) {
+		super(teams, plists, reuseTeams, teamsPerSession, sesettings,
+				nTournaments);
+		this.learnSettings = learnSet;
+	}
+
+	@Override
+	public TournamentProtocol getProtocol(Reporter logger) {
+		AllPermutationsLearnState state = new AllPermutationsLearnState(this,
+				permutations(), Collections.emptyList());
+		return new AllPermutationsLearnProtocol(state, logger);
+	}
+
+	@Override
+	public Double getMaxRunTime() {
+		return super.permutations().size().doubleValue()
+				* (sessionsettings.getMaxRunTime() + 2d)
+				+ learnSettings.getMaxRunTime();
+	}
+
+	/**
+	 * @return {@link ImmutableList} containing all {@link SessionSettings} for
+	 *         all Sessions in the correct order.
+	 */
+	@Override
+	public ImmutableList<SessionSettings> permutations() {
+		ImmutableList<SessionSettings> allsessionsettings = super.permutations();
+		if (allsessionsettings.size()
+				.compareTo(BigInteger.valueOf(MAX_SESSIONS)) > 0)
+			throw new IllegalArgumentException(
+					"learn-tournament exceeds max number of sessions  "
+							+ MAX_SESSIONS);
+
+		FixedList<FixedList<FileLocation>> filelocs = createFileLocations(
+				allsessionsettings.size().longValue());
+
+		ImmutableList<ImmutableList<TeamInfo>> partylistlist;
+		ImmutableList<Team> partieslist = new FixedList<Team>(teams);
+		ImmutableList<ProfileList> profileslist = new FixedList<ProfileList>(
+				profileslists);
+		partylistlist = getParticipants(partieslist, profileslist,
+				teamsPerSession, reuseTeams);
+		ImmutableList<SessionSettings> settings = new MapThreadList<>(
+				(parties, flocs) -> createSetting(parties, flocs),
+				partylistlist, filelocs);
+
+		return new JoinedList<SessionSettings>(settings,
+				getLearnSessions(filelocs, partylistlist));
+	}
+
+	@Override
+	public String toString() {
+		return "AllPermutationsLearnSettings[" + contentString() + ","
+				+ learnSettings + "]";
+	}
+
+	/**
+	 * 
+	 * @param numsessions the number of sessions in the tournament
+	 * @return A list of list of {@link FileLocation}s. The outer list has one
+	 *         entry for each session, the inner list has one
+	 *         {@link FileLocation} per party.
+	 */
+	private FixedList<FixedList<FileLocation>> createFileLocations(
+			long numsessions) {
+		// like before, but all sessions need a new negotiationdata
+		List<FixedList<FileLocation>> filelocations = new ArrayList<>();
+		for (long sessionnr = 0; sessionnr < numsessions; sessionnr++) {
+			List<FileLocation> locs = new ArrayList<>();
+			for (int teamnr = 0; teamnr < teamsPerSession; teamnr++) {
+				locs.add(new FileLocation());
+			}
+			filelocations.add(new FixedList<>(locs));
+		}
+		FixedList<FixedList<FileLocation>> filelocs = new FixedList<>(
+				filelocations);
+		return filelocs;
+	}
+
+	/**
+	 * @param allsessionsettings the 'traditional session settings.
+	 * @param filelocs           the {@link FileLocation}s for each session, for
+	 *                           each party
+	 * @param partylistlist      the lists of all teams for the sessions, with
+	 *                           unaltered parameters matching the
+	 *                           {@link #teams} list
+	 * @return the final sessions, doing learning for all parties. In this
+	 *         session, the number of parties may be larger than
+	 *         {@link #teamsPerSession}. Learning may be spread over multiple
+	 *         sessions, although we don't do this currently.
+	 */
+	private ImmutableList<SessionSettings> getLearnSessions(
+			FixedList<FixedList<FileLocation>> filelocs,
+			ImmutableList<ImmutableList<TeamInfo>> partylistlist) {
+		try {
+			ProfileRef NOPROFILE = new ProfileRef("not://aprofile");
+
+			SessionSettings session = learnSettings;
+			// add all the teams, with updated parameters, to the session
+			for (Team team : teams) {
+				List<FileLocation> files = getNegoData(team, filelocs,
+						partylistlist);
+				// Tricky: correct parameter is list of UUID strings
+				List<String> filesstrings = files.stream()
+						.map(file -> file.getUUIDString())
+						.collect(Collectors.toList());
+				Parameters parameters = new Parameters().with("negotiationdata",
+						filesstrings);
+				// add all the FileLocations and NOPROFILE to all team members
+				List<PartyWithProfile> teaminfo = team.getParties().stream()
+						.map(pwp -> new PartyWithProfile(pwp.with(parameters),
+								NOPROFILE))
+						.collect(Collectors.toList());
+				session = session.with(new TeamInfo(teaminfo));
+			}
+
+			return new FixedList<SessionSettings>(Arrays.asList(session));
+		} catch (URISyntaxException e) {
+			throw new RuntimeException("Failed creating learn session", e);
+		}
+	}
+
+	/**
+	 * @param team     the team for which the {@link FileLocation}s are needed
+	 * @param filelocs the used {@link FileLocation}s for all sessions, all
+	 *                 teams.
+	 * @param TeamInfo the TeamInfo used for each session, team. Same dimensions
+	 *                 as filelocs
+	 * @return the list of FileLocations that were provided to the given team in
+	 *         the negotiation sessions.
+	 */
+	private List<FileLocation> getNegoData(Team team,
+			FixedList<FixedList<FileLocation>> filelocs,
+			ImmutableList<ImmutableList<TeamInfo>> partylistlist) {
+		List<FileLocation> locs = new ArrayList<>();
+		for (long sessionnr = 0; sessionnr < filelocs.size()
+				.longValue(); sessionnr++) {
+			for (int teamnr = 0; teamnr < teamsPerSession; teamnr++) {
+				if (team.equals(
+						partylistlist.get(sessionnr).get(teamnr).getTeam()))
+					locs.add(filelocs.get(sessionnr).get(teamnr));
+			}
+		}
+		return locs;
+
+	}
+
+	/**
+	 * 
+	 * @param partyproflist a list of {@link PartyWithProfile} settings. Now,
+	 *                      each party gets a new negotiationdata object in
+	 *                      every session.
+	 * @param locs          the FileLocations for the negotiationdata for all
+	 *                      teams
+	 * @return {@link SessionSettings}, with each party parameters extended with
+	 *         its {@link FileLocation}
+	 */
+	private SessionSettings createSetting(ImmutableList<TeamInfo> partyproflist,
+			ImmutableList<FileLocation> locs) {
+		SessionSettings settings = sessionsettings;
+		for (int teamnr = 0; teamnr < partyproflist.size()
+				.intValue(); teamnr++) {
+			Parameters extraparams = new Parameters().with("negotiationdata",
+					Arrays.asList(locs.get(teamnr)));
+			TeamInfo teaminfo = partyproflist.get(teamnr).with(extraparams);
+			settings = settings.with(teaminfo);
+		}
+		return settings;
+	}
+
+}
Index: protocol/src/main/java/geniusweb/protocol/tournament/allpermutationslearn/AllPermutationsLearnState.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/tournament/allpermutationslearn/AllPermutationsLearnState.java	(revision 31)
+++ protocol/src/main/java/geniusweb/protocol/tournament/allpermutationslearn/AllPermutationsLearnState.java	(revision 31)
@@ -0,0 +1,38 @@
+package geniusweb.protocol.tournament.allpermutationslearn;
+
+import java.util.ArrayList;
+import java.util.List;
+
+import geniusweb.protocol.session.SessionResult;
+import geniusweb.protocol.session.SessionSettings;
+import geniusweb.protocol.tournament.allpermutations.AllPermutationsState;
+import tudelft.utilities.immutablelist.ImmutableList;
+
+/**
+ * A non-parallel simple implementation of all-permutations
+ */
+public class AllPermutationsLearnState extends AllPermutationsState {
+
+	public AllPermutationsLearnState(AllPermutationsLearnSettings toursettings,
+			ImmutableList<SessionSettings> settings,
+			List<SessionResult> results) {
+		super(toursettings, settings, results);
+	}
+
+	/**
+	 * 
+	 * @param result the next {@link SessionResult}
+	 * @return new state
+	 * @throws IllegalArgumentException if the result participants are not
+	 *                                  matching the expected participants
+	 */
+	@Override
+	public AllPermutationsLearnState with(SessionResult result) {
+		ArrayList<SessionResult> newresults = new ArrayList<>(results);
+		newresults.add(result);
+		return new AllPermutationsLearnState(
+				(AllPermutationsLearnSettings) toursettings, sessionsettings,
+				newresults);
+	}
+
+}
Index: protocol/src/test/java/geniusweb/protocol/session/learn/LearnSettingsTest.java
===================================================================
--- protocol/src/test/java/geniusweb/protocol/session/learn/LearnSettingsTest.java	(revision 31)
+++ protocol/src/test/java/geniusweb/protocol/session/learn/LearnSettingsTest.java	(revision 31)
@@ -0,0 +1,222 @@
+package geniusweb.protocol.session.learn;
+
+import static org.junit.Assert.assertEquals;
+import static org.mockito.Mockito.mock;
+
+import java.io.IOException;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.deadline.Deadline;
+import geniusweb.deadline.DeadlineRounds;
+import geniusweb.protocol.session.SessionSettings;
+import geniusweb.protocol.session.TeamInfo;
+import geniusweb.references.Parameters;
+import geniusweb.references.PartyRef;
+import geniusweb.references.PartyWithParameters;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProfileRef;
+import tudelft.utilities.junit.GeneralTests;
+import tudelft.utilities.logging.Reporter;
+
+public class LearnSettingsTest extends GeneralTests<LearnSettings> {
+	private final ObjectMapper jackson = new ObjectMapper();
+	LearnSettings settings1, settings1a, settings2, settings3;
+	private DeadlineRounds deadline;
+	private List<TeamInfo> participants, participants2;
+	private Parameters params;
+
+	private final String serialized = "{\"LearnSettings\":{\"participants\":[{\"TeamInfo\":{\"parties\":[{\"party\":{\"partyref\":\"party1\",\"parameters\":{\"persistentstate\":\"6bb5f909-0079-43ac-a8ac-a31794391074\",\"negotiationdata\":[\"12b5f909-0079-43ac-a8ac-a31794391012\"]}},\"profile\":\"http://prof1\"}]}}],\"deadline\":{\"deadlinerounds\":{\"rounds\":10,\"durationms\":10000}}}}";
+
+	@Before
+	public void before() throws URISyntaxException, JsonProcessingException {
+
+		params = new Parameters();
+		params = params.with("persistentstate",
+				"6bb5f909-0079-43ac-a8ac-a31794391074");
+		params = params.with("negotiationdata",
+				Arrays.asList(("12b5f909-0079-43ac-a8ac-a31794391012")));
+
+		// define participants
+		participants = createTeam(params, 1);
+
+		// participants2
+//		ProfileRef profile2 = new ProfileRef("http://prof2");
+//		PartyWithProfile partywithp2 = new PartyWithProfile(party1, profile2);
+//		List<PartyWithProfile> team2pp = Arrays.asList(partywithp2);
+//		TeamInfo team2 = new TeamInfo(team2pp);
+		participants2 = createTeam(params, 2);
+
+		deadline = new DeadlineRounds(10, 10000);
+		Deadline deadline2 = new DeadlineRounds(20, 10000);
+
+		settings1 = new LearnSettings(participants, deadline);
+		settings1a = new LearnSettings(participants, deadline);
+		settings2 = new LearnSettings(participants2, deadline);
+		settings3 = new LearnSettings(participants, deadline2);
+
+	}
+
+	/**
+	 * 
+	 * @param params  the parameters for the party
+	 * @param partynr the serialnr for the party, eg 1 or 2.
+	 * @return a List of TeamInfo with just 1 team.
+	 */
+	private List<TeamInfo> createTeam(Parameters params, int partynr)
+			throws URISyntaxException {
+		PartyRef party1ref = new PartyRef("party" + partynr);
+		PartyWithParameters party1 = new PartyWithParameters(party1ref, params);
+		ProfileRef profile1 = new ProfileRef("http://prof" + partynr);
+		PartyWithProfile partywithp1 = new PartyWithProfile(party1, profile1);
+		List<PartyWithProfile> team1pp = Arrays.asList(partywithp1);
+		TeamInfo team1 = new TeamInfo(team1pp);
+		return Arrays.asList(team1);
+
+	}
+
+	@Override
+	public List<List<LearnSettings>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(settings1, settings1a),
+				Arrays.asList(settings2), Arrays.asList(settings3));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"LearnSettings.TeamInfo.*PartyWithProfile.*PartyRef.*party1.*persistentstate=6b.*, negotiationdata=\\[12.*..*ProfileRef.*prof1.*,DeadlineRounds.*10,10000.*",
+				"LearnSettings.TeamInfo.*PartyWithProfile.*PartyRef.*party2.*persistentstate=6b.*, negotiationdata=\\[12.*..*ProfileRef.*prof2.*,DeadlineRounds.*10,10000.*",
+				"LearnSettings.TeamInfo.*PartyWithProfile.*PartyRef.*party1.*persistentstate=6b.*, negotiationdata=\\[12.*..*ProfileRef.*prof1.*,DeadlineRounds.*20,10000.*");
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void testNullParticipants() {
+		new LearnSettings(null, deadline);
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void testNullDeadline() {
+		new LearnSettings(participants, null);
+	}
+
+	@Test
+	public void getMaxRuntimeTest() {
+		assertEquals(10d, settings1.getMaxRunTime(), 0.00000001);
+	}
+
+	@SuppressWarnings("unused")
+	@Test
+	public void getProtocolTest() {
+		// this will throw if not Learn protocol or another problem.
+		Learn protocol = (Learn) settings1.getProtocol(mock(Reporter.class));
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void badPersistentTest() throws URISyntaxException {
+		// hack. #1933.
+		Parameters newparams = params.with("persistentstate",
+				"\"notproperUUID\"");
+		participants = createTeam(newparams, 1);
+
+		new LearnSettings(participants, deadline);
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void persistentNotStringTest() throws URISyntaxException {
+		Parameters newparams = params.with("persistentstate", 32);
+		participants = createTeam(newparams, 1);
+
+		new LearnSettings(participants, deadline);
+	}
+
+	@SuppressWarnings("unused")
+	@Test
+	public void persistentWithoutQuotesTest() throws URISyntaxException {
+		Parameters newparams = params.with("persistentstate",
+				"6bb5f909-0079-43ac-a8ac-a31794391074");
+		participants = createTeam(newparams, 1);
+
+		new LearnSettings(participants, deadline);
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void persistentExtraQuoteTest() throws URISyntaxException {
+		Parameters newparams = params.with("persistentstate",
+				"\"6bb5f909-0079-43ac-a8ac-a31794391074\"");
+		participants = createTeam(newparams, 1);
+
+		new LearnSettings(participants, deadline);
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void negotiationDataNotList() throws URISyntaxException {
+		Parameters newparams = params.with("negotiationdata",
+				"\"12b5f909-0079-43ac-a8ac-a31794391012\"");
+		participants = createTeam(newparams, 1);
+		new LearnSettings(participants, deadline);
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void negotiationDataBadContents() throws URISyntaxException {
+		Parameters newparams = params.with("negotiationdata", "\"bad\"");
+		participants = createTeam(newparams, 1);
+		new LearnSettings(participants, deadline);
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void negotiationDataNotString() throws URISyntaxException {
+		Parameters newparams = params.with("negotiationdata", 12);
+		participants = createTeam(newparams, 1);
+		new LearnSettings(participants, deadline);
+	}
+
+	@Test
+	public void getTeamsTest() {
+		assertEquals(participants, settings1.getTeams());
+		assertEquals((Integer) 1, settings1.getTeamSize());
+	}
+
+	@Test
+	public void getDeadlineTest() {
+		assertEquals(deadline, settings1.getDeadline());
+	}
+
+	@Test
+	public void withTeamTest() {
+		SessionSettings newset = settings1.with(participants2.get(0));
+		assertEquals(2, newset.getTeams().size());
+	}
+
+	@Test
+	public void testDeserialize() throws IOException {
+		SessionSettings obj = jackson.readValue(serialized,
+				SessionSettings.class);
+		System.out.println(obj);
+		assertEquals(settings1, obj);
+	}
+
+	@Test
+	public void testSerialize()
+			throws JsonProcessingException, URISyntaxException {
+
+		String string = jackson.writeValueAsString(settings1);
+		System.out.println(string);
+		assertEquals(serialized, string);
+	}
+
+}
Index: protocol/src/test/java/geniusweb/protocol/session/learn/LearnStateTest.java
===================================================================
--- protocol/src/test/java/geniusweb/protocol/session/learn/LearnStateTest.java	(revision 31)
+++ protocol/src/test/java/geniusweb/protocol/session/learn/LearnStateTest.java	(revision 31)
@@ -0,0 +1,162 @@
+package geniusweb.protocol.session.learn;
+
+import static org.junit.Assert.assertEquals;
+import static org.junit.Assert.assertFalse;
+import static org.junit.Assert.assertNotNull;
+import static org.junit.Assert.assertNull;
+import static org.junit.Assert.assertTrue;
+import static org.mockito.Matchers.any;
+import static org.mockito.Mockito.mock;
+import static org.mockito.Mockito.when;
+
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import geniusweb.actions.EndNegotiation;
+import geniusweb.actions.LearningDone;
+import geniusweb.actions.PartyId;
+import geniusweb.deadline.Deadline;
+import geniusweb.deadline.DeadlineTime;
+import geniusweb.inform.Agreements;
+import geniusweb.progress.Progress;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.session.SessionResult;
+import geniusweb.protocol.session.TeamInfo;
+import geniusweb.references.Parameters;
+import geniusweb.references.PartyRef;
+import geniusweb.references.PartyWithParameters;
+import geniusweb.references.PartyWithProfile;
+import geniusweb.references.ProfileRef;
+
+public class LearnStateTest {
+
+	private static final String PARTY2 = "party2";
+	private static final String PARTY1 = "party1";
+	private static final PartyId party1id = new PartyId(PARTY1);
+	private static final PartyId party2id = new PartyId(PARTY2);
+	private LearnState state;
+	private final Deadline deadline = new DeadlineTime(10000);
+	private Parameters params;
+	private PartyWithProfile partyprofile1 = mock(PartyWithProfile.class);
+	private PartyWithProfile partyprofile2 = mock(PartyWithProfile.class);
+	private LearnState connectedstate;
+	private final Progress progressnotdone = mock(Progress.class);
+	private final Progress progressdone = mock(Progress.class);
+
+	@Before
+	public void before() throws URISyntaxException {
+		TeamInfo team1, team2;
+		params = new Parameters();
+		params = params.with("persistentstate",
+				"6bb5f909-0079-43ac-a8ac-a31794391074");
+		params = params.with("negotiationdata",
+				Arrays.asList("12b5f909-0079-43ac-a8ac-a31794391012"));
+
+		when(progressnotdone.isPastDeadline(any())).thenReturn(false);
+		when(progressdone.isPastDeadline(any())).thenReturn(true);
+
+		// define team1
+		PartyRef party1ref = new PartyRef(PARTY1);
+		PartyWithParameters party1 = new PartyWithParameters(party1ref, params);
+		ProfileRef profile1 = new ProfileRef("http://prof1");
+		PartyWithProfile partywithp1 = new PartyWithProfile(party1, profile1);
+		List<PartyWithProfile> team1pp = Arrays.asList(partywithp1);
+		team1 = new TeamInfo(team1pp);
+
+		// define team2
+		PartyRef party2ref = new PartyRef(PARTY2);
+		PartyWithParameters party2 = new PartyWithParameters(party1ref, params);
+		ProfileRef profile2 = new ProfileRef("http://prof2");
+		PartyWithProfile partywithp2 = new PartyWithProfile(party2, profile2);
+		List<PartyWithProfile> team2pp = Arrays.asList(partywithp2);
+		team2 = new TeamInfo(team1pp);
+
+		List<TeamInfo> participants = Arrays.asList(team1, team2);
+		LearnSettings settings = new LearnSettings(participants, deadline);
+		this.state = new LearnState(settings);
+
+		this.connectedstate = state.with(party1id, partyprofile1)
+				.with(party2id, partyprofile2).with(progressnotdone);
+
+	}
+
+	@SuppressWarnings("unused")
+	@Test(expected = IllegalArgumentException.class)
+	public void smokeTestNull() {
+		new LearnState(null);
+	}
+
+	@SuppressWarnings("unused")
+	@Test
+	public void smokeTest() {
+		LearnSettings settings = mock(LearnSettings.class);
+		new LearnState(settings);
+	}
+
+	@Test
+	public void getAgreementsTest() {
+		assertEquals(new Agreements(), state.getAgreements());
+	}
+
+	@Test
+	public void isFinalTest() {
+		// initial state is false, because we check
+		// that there are no learningDone reports
+		assertFalse(state.isFinal(0));
+		// not final because there are connected parties not yet done.
+		assertFalse(connectedstate.isFinal(0));
+		LearnState finalstate = connectedstate.with(progressdone);
+		assertTrue(finalstate.isFinal(0));
+
+		LearnState errorstate = connectedstate
+				.with(new ProtocolException("test", party1id));
+		assertTrue(errorstate.isFinal(0));
+	}
+
+	@Test
+	public void checkActionTest() {
+		// check basic illegal actions in Learning
+		assertNotNull(connectedstate.checkAction(party1id, null));
+		assertNotNull(connectedstate.checkAction(new PartyId("unknown"), null));
+		assertNotNull(connectedstate.checkAction(party1id,
+				new EndNegotiation(party1id)));
+		assertNotNull(connectedstate.checkAction(party1id,
+				new LearningDone(party2id)));
+
+		// check a good action is allowed
+		assertNull(connectedstate.checkAction(party1id,
+				new LearningDone(party1id)));
+
+		// no learning twice not ok
+		LearnState learned = connectedstate.with(party1id,
+				new LearningDone(party1id));
+		assertNotNull(
+				learned.checkAction(party1id, new LearningDone(party1id)));
+	}
+
+	@SuppressWarnings("unused")
+	@Test
+	public void LearnDoneActionTest() {
+		LearnState learned = connectedstate.with(party1id,
+				new LearningDone(party1id));
+	}
+
+	@SuppressWarnings("unused")
+	@Test
+	public void isFinalWhenAllLearned() {
+		LearnState learned = connectedstate
+				.with(party1id, new LearningDone(party1id))
+				.with(party2id, new LearningDone(party2id));
+		assertTrue(learned.isFinal(0));
+	}
+
+	@Test
+	public void getResultTest() {
+		SessionResult res = connectedstate.getResult();
+		assertTrue(res.getAgreements().getMap().isEmpty());
+	}
+}
